/******************************************************************************
Filename:     modHwExtSimpleImpl.c
Target:       TLN13SP01

Description:
building block layer module library: hardware part

һּ򵥵modHwExt.hӿڵʵַʽ

֧2LEDled0: GPIO13, led1: GPIO11


modification:
2015.01.25 creation Zheng Hui

Zheng Hui, Guangzhou, China. hzheng@gzhu.edu.cn. Guangzhou University

******************************************************************************/
#include "wm_gpio.h"

#include "modHwExt.h"


#define LED1          13
#define LED2          11
#define LED_OFF          1
#define LED_ON           0


/**
 * LEDʼӿ
 * עLEDĿӦӲء
 */
int8 modLedInit(){
	tls_gpio_cfg(LED1, TLS_GPIO_DIR_OUTPUT, TLS_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(LED2, TLS_GPIO_DIR_OUTPUT, TLS_GPIO_ATTR_FLOATING);
	tls_gpio_write(LED1,LED_OFF);
	tls_gpio_write(LED2,LED_OFF);
  return 0;
}

/**
 * LED״̬ýӿ
 * Set specified LED to specified state.
 * 
 *       vLedId: 0-n
 *       vLedState: 0 = off, 1 = on, 2 = toggle
 * return:
 *       0=success, -1 = unsupported vLedId, -2 = unsupported vLedState
 */
int8 modSetLedState(uint8 vLedId, uint8 vLedState) {
  if (vLedId>1) {
    return -1;
  }
  if (vLedState >2) {
    return -2;
  }
  if (vLedState == 0) {
    switch(vLedId)  {
      case (0):
				tls_gpio_write(LED1,LED_OFF);
        break;
      case (1):
				tls_gpio_write(LED2,LED_OFF);
        break;
      default:
        ;
    }
  }else if (vLedState == 1) {
    switch(vLedId)  {
      case (0):
				tls_gpio_write(LED1,LED_ON);
        break;
      case (1):
				tls_gpio_write(LED2,LED_ON);
        break;
      default:
        ;
    }
  }else {
    switch(vLedId)  {
      case (0):
				if (tls_gpio_read(LED1)==LED_ON) {
					tls_gpio_write(LED1,LED_OFF);
				}else {
					tls_gpio_write(LED1,LED_ON);
				}
        break;
      case (1):
				if (tls_gpio_read(LED2)==LED_ON) {
					tls_gpio_write(LED2,LED_OFF);
				}else {
					tls_gpio_write(LED2,LED_ON);
				}
        break;
      default:
        ;
    }
  }
  return 0;
}

