
/*+**********************************************************************************
  Filename: main.c

  Description: 
	  main function of application.
		
		A simple app toggles leds via user task and software delay.

  Modification:
    2015.01.25 creation by Zheng Hui

**********************************************************************************-*/
#include <stdio.h>
#include "wm_osal.h"

#include "modSys.h"
#include "modHwExt.h"
#include "modUart.h"

/**
 * 
 */
#define     TASK_STK_SIZE         256     /* Size of each task's stacks (# of WORDs)  */
#define     MY_TASK_PRIO      50
/**
 * ȫֱ
 */
OS_STK      mMyLedToggleTaskStack[TASK_STK_SIZE];         /* Tasks stacks */

/**
 * 
 */
void myLedToggleTask(void *data);
void myUartRxCallbackFunction(uint8 vUartNumber, uint8 vSize, uint8* vPacket); //Uart Rx Callback

/**
 * 
 */
int main( void ) {

  modSysInit();

  modSysRun();

}



/**
 * user app init
 */
void CreateUserTask(void) {
	uint8 pWellcomeMsg[] = "uart ready";
	
	//app init
  modLedInit();
	modSetLedState(0,1);
	
	modUartInit(1,115200);
	modUartSetRxCallback(myUartRxCallbackFunction);
	modUartSendPkt(1, 11, pWellcomeMsg);
	
  //
	printf("\n user task\n");
	
	//start led control task
		tls_os_task_create(NULL, NULL,
                    myLedToggleTask,
                    (void *)0,
                    (void *)mMyLedToggleTaskStack,      
                    TASK_STK_SIZE * sizeof(u32),
                    MY_TASK_PRIO,
                    0);

}

/**
 * user app task
 */
void myLedToggleTask(void *data) {
	for (;;) { //loop
		modSetLedState(1,2);
		modDelay(1000);
		
	}
}

/**
 * UART Rx Callback
 */
void myUartRxCallbackFunction(uint8 vUartNumber, uint8 vSize, uint8* vPacket){
  //toggle led 0
	modSetLedState(0,2);
	//send it back
	modUartSendPkt(1, vSize, vPacket);
}

